export const colorLegend = (parent, props) => {
  const {
    colorScale,
    circleRadius,
    legendSpacing,
    textOffset,
    onClick,
    selectedLegendItem,
    legendWidth
  } = props; //Unpack parameters
	
  const gRect = parent.selectAll('rect').data([null]);
  gRect
    .enter()
    .append('rect')
    	.attr('class', 'legend')
    .merge(gRect)
      .attr('x', -10)
      .attr('y', -10)
      .attr('rx', circleRadius)
      .attr('width', legendWidth)
      .attr(
        'height',
        legendSpacing * colorScale.domain().length + legendSpacing / 2
      )
      .attr('class', 'legend');

  const groups = parent.selectAll('.tick').data(colorScale.domain());
  const groupsEnter = groups.enter().append('g').attr('class', 'tick');
  groupsEnter
    .merge(groups)
    .attr('transform', (d, i) => `translate(0, ${i * legendSpacing})`)
  	.attr('opacity', d => (!selectedLegendItem || d===selectedLegendItem) ? 1 : 0.5)
    .on('click', d => onClick(
        d === selectedLegendItem
          ? null
          : d
      ))

    ;
  
  groups.exit().remove();

  groupsEnter
    .append('circle')
    .merge(groups.select('circle'))

    .transition()
    .duration(1000)
    .attr('fill', (d) => colorScale(d))
    .attr('stroke-width', 5)
    .attr('r', circleRadius)
    .attr('cx', (d, i) => 0);

  groupsEnter.append('text')
    .merge(groups.select('text'))   
      .text(d => d)
      .attr('dy', '0.32em')
      .attr('x', textOffset);
};
